--Battle Announcer script by DirkTheHusky
--Lua assist by Krabs

local pinchtime = 31
local announcertime = TICRATE

freeslot(
	'sfx_smba01',
	'sfx_smba02',
	'sfx_smba03',
	'sfx_smba04',
	'sfx_smba05',
	'sfx_smba06',
	'sfx_smba07',
	'sfx_smba08',
	'sfx_smba09',
	'sfx_smba10',
	'sfx_smbhyu',
	'sfx_smbrdy',
	'sfx_smbfgt',
	'sfx_smbsud',
	'sfx_smbsta',
	'sfx_smbtim',
	'sfx_smbfin',
	'sfx_smbkno',
	'sfx_smblos',
	'sfx_smbfal',
	'sfx_smbcap',
	'sfx_smbgov',
	'sfx_smbc01',
	'sfx_smbc02',
	'sfx_smbago'
)

local filename = "client/battleannouncer.dat"
local announcer_enabled = true

local file = io.openlocal(filename, "r")
if file then
    if file:read("*n") == 0
		announcer_enabled = false
	end
end

COM_AddCommand("battleannouncer", function(player, arg)
    if arg == "on" or arg == "1" or arg == "true"
        if player == consoleplayer
            local file = io.openlocal(filename, "w+")
            print("Battle Announcer enabled")
            file:write(1)
            file:close()
            announcer_enabled = true
        end
    elseif arg == "off" or arg == "0" or arg == "false"
        if player == consoleplayer
            local file = io.openlocal(filename, "w+")
            print("Battle Announcer disabled")
            file:write(0)
            file:close()
            announcer_enabled = false
        end
    elseif player == consoleplayer
        local onoff = "enabled."
        if announcer_enabled == false
            onoff = "disabled."
        end
        print("Toggles the announcer. Announcer is currently "+onoff)
    end
end)

local voice = function(sfx, override)
	local B = CBW_Battle
	if not announcer_enabled
	return end
	
	if B.announcerplaying == false or override
		S_StartSoundAtVolume(nil, sfx, 220)
		B.announcerplaying = true
		B.announcerinvoice = announcertime
	end
end

local gameset = false
local gamesetdelay = 0
local announcerCountdown = function()
	local B = CBW_Battle
	local CV = B.Console
	if not (B and B.BattleGametype())
		return
	end
	
	if B.Exiting
		gamesetdelay = $ + 1
		if gameset == false and gamesetdelay > 16
			gameset = true
			voice(sfx_smbfin, true)
		end
		return
	else
		gameset = false
	end

	--Vars
	local t 			= CV_FindVar("timelimit")
	local ot 			= CV_FindVar("overtime")
	local ht			= CV_FindVar("hidetime")
	local pre_pinch 	= (t.value*60-pinchtime)
	local timeleft 		= pre_pinch-leveltime/TICRATE
	local pinch 		= timeleft < 0
	local overtime 		= ((ot.value) and (gametyperules & GTR_OVERTIME) and t.value*60-leveltime/TICRATE <= 0)
	--local preparedtime	= (t.value*60)-(ht.value*60)/TICRATE
	local suddendeath 	= (B.Gametypes.SuddenDeath[gametype] and overtime and CV.SuddenDeath.value == 1)
	local announcerplaying = false
	local preroundtime = ht.value-leveltime/TICRATE

	
	--Check game mode conditions
	
	if B.announcerinvoice == nil
		B.announcerinvoice = 0
	end
	
	if B.announcerinvoice > 0
		B.announcerinvoice = $-1
	end
	
	if B.announcerinvoice == 0
		B.announcerplaying = false
	end
	
	if not(B.PreRoundWait())
	and gametyperules&GTR_TIMELIMIT and t.value and pinch
		--Pinch phase stuff
		if not(overtime)
			local leveltimeoffset = leveltime + 25
			if ((t.value*60-leveltimeoffset) % TICRATE == 0)
				local num = t.value*60-leveltimeoffset/TICRATE
				if num == 30
					voice(sfx_smbhyu)
				elseif num <= 10
					voice(sfx_smba01 + num - 1)
				end
			end
		end
		if overtime
		and t.value*60-leveltime/TICRATE == 0
			voice(sfx_smbsud)
		end
	end
	if preroundtime >= 0
		if preroundtime == ht.value-2
			voice(sfx_smbrdy)
		elseif preroundtime <= 3
		and not (preroundtime <= 0)
			voice(sfx_smba01 + preroundtime - 1)
		elseif preroundtime == 0
			if B.ArenaGametype()
				voice(sfx_smbfgt)
			else
				voice(sfx_smbago)
			end
		end
	end
	/*if t.value*60-leveltime/TICRATE == preparedtime+23
		voice(sfx_smbrdy)
	elseif t.value*60-leveltime/TICRATE == preparedtime+13
		voice(sfx_smba03)
	elseif t.value*60-leveltime/TICRATE == preparedtime+12
		voice(sfx_smba02)
	elseif t.value*60-leveltime/TICRATE == preparedtime+11
		voice(sfx_smba01)
	elseif t.value*60-leveltime/TICRATE == preparedtime+10
		voice(sfx_smbfgt)
	end*/
end

--This replaces battle's KillReward function, in order to properly track the player's lifeshard count
--Plays a sound effect for the killer
local announcerKill = function(killer)
	local B = CBW_Battle
	local CV = B.Console
	
	if not (killer and killer.valid) return end
	if B.SuddenDeath then return end
	local survival = G_GametypeUsesLives() and B.ArenaGametype()
	
	if killer.lifeshards == nil
		killer.lifeshards = 0
	end
	
	S_StartSound(nil, sfx_s249, killer)
	
	if killer.mo and killer.mo.valid and killer.playerstate == PST_LIVE and not killer.revenge
		if killer.lives >= CV.SurvivalStock.value or not survival
			killer.lifeshards = 0
		else
			killer.lifeshards = $ + 1
		end
		
		killer.rings = $ + 20
		S_StartSound(killer.mo, sfx_itemup, killer)
		S_StartSound(killer.mo, sfx_s249, killer)
		
		if (killer.lifeshards == 0) or not survival
			P_SpawnParaloop(killer.mo.x, killer.mo.y, killer.mo.z + (killer.mo.height / 2), 12 * FRACUNIT, 9, MT_NIGHTSPARKLE, ANGLE_90)
			--if killer == displayplayer
				--voice(sfx_smbkno)
			--end
		elseif killer.lifeshards == 1
			S_StartSound(nil, sfx_s243, killer)
			P_SpawnParaloop(killer.mo.x, killer.mo.y, killer.mo.z + (killer.mo.height / 2), 12 * FRACUNIT, 9, MT_NIGHTSPARKLE, ANGLE_90)
			--if killer == displayplayer
				--voice(sfx_smbc01)
			--end
		elseif killer.lifeshards == 2
			S_StartSound(nil, sfx_s243a, killer)
			P_SpawnParaloop(killer.mo.x, killer.mo.y, killer.mo.z + (killer.mo.height / 2), 12 * FRACUNIT, 12, MT_NIGHTSPARKLE, ANGLE_90)
			--if killer == displayplayer
				--voice(sfx_smbc02)
			--end
		elseif killer.lifeshards == 3
			P_SpawnParaloop(killer.mo.x, killer.mo.y, killer.mo.z + (killer.mo.height / 2), 12 * FRACUNIT, 15, MT_NIGHTSPARKLE, ANGLE_90)
			if killer == displayplayer
				voice(sfx_smbc02)
			end
		end
		
		if (killer.lifeshards == 3) and survival
			killer.lifeshards = 0
			killer.lives = $ + 1
			P_PlayLivesJingle(killer)
			local icon = P_SpawnMobjFromMobj(killer.mo,0,0,0,MT_1UP_ICON)
			icon.scale = killer.mo.scale * 4/3
			print("\x89" .. killer.name .. " earned an extra life!")
		else
			local icon = P_SpawnMobjFromMobj(killer.mo,0,0,0,MT_RING_ICON)
			icon.scale = killer.mo.scale
		end
	end
end

--Plays a sound effect for the victim
local announcerDeath = function(target,inflictor,source,damagetype)
	if not (target.player and target.player == displayplayer)
		return
	end
	
	if damagetype == DMG_DEATHPIT
		voice(sfx_smbfal)
	elseif G_GametypeUsesLives() and CBW_Battle.ArenaGametype() and target.player.lives == 0
		voice(sfx_smggov)
	end
end

local prevred = 0
local prevblue = 0
local announcerCTF = function()
	local B = CBW_Battle
	local CV = B.Console
	if not (B and B.BattleGametype())
		return
	end
	
	if not (gametyperules & GTR_TEAMFLAGS)
		return
	end
	
	if B.RedScore != prevred
		prevred = B.RedScore
		if displayplayer and displayplayer.ctfteam == 2--enemy team capped
			voice(sfx_smblos)
		else
			voice(sfx_smbcap)--my team capped, or im spectating
		end
	end
	
	if B.BlueScore != prevblue
		prevblue = B.BlueScore
		if displayplayer and displayplayer.ctfteam == 1--enemy team capped
			voice(sfx_smblos)
		else
			voice(sfx_smbcap)--my team capped, or im spectating
		end
	end
end

local announcerSelectStage = function()
	if MapVoteNet and announcer_enabled
		local NET = MapVoteNet
		if NET.timer == 10 and  NET.state == MV_VOTE
			voice(sfx_smbsta, true)
		end
	end
end

--Wait for battle's pk3 to be added before replacing the KillReward function
local replaced = false
local replaceKillRewardFunc = function()
	if CBW_Battle and not replaced
		replaced = true
		CBW_Battle.Arena.KillReward = announcerKill
	end
end

local announcerReset = function()
	gameset = false
	gamesetdelay = 0
	prevred = 0
	prevblue = 0
end

local netsync = function(n)
	gameset = n($)
	gamesetdelay = n($)
	prevred = n($)
	prevblue = n($)
end

addHook("ThinkFrame",announcerCountdown)
addHook("ThinkFrame",announcerCTF)
addHook("ThinkFrame",replaceKillRewardFunc,MT_PLAYER)
addHook("MobjDeath",announcerDeath,MT_PLAYER)
addHook("IntermissionThinker", announcerSelectStage)
addHook("MapChange", announcerReset)
addHook("NetVars", netsync)